
/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

#define __ATTR_RAM_D1   __attribute__ ((section(".RAM_D1"))) __attribute__ ((aligned (4)))
#define 	GPIO_SSN_1 LL_GPIO_SetOutputPin(GPIOE, LL_GPIO_PIN_11)
#define 	GPIO_SSN_0 LL_GPIO_ResetOutputPin(GPIOE, LL_GPIO_PIN_11)

#define REFCLK 5000000
#define REFCLK_DIVISIONS ((uint32_t)65536) // setup according to your needs

#define CFG0 	0b00110101 // Enable PECL_OUT, STOPA, REFCLK
#define CFG1 	0b10000101 // High REsolution, STOPA
//#define CFG2 	0b00001000 // 16bit STOP, 0bit REFINDEX
//#define CFG2 	0b00010000 // 18bit STOP, 0bit REFINDEX
//#define CFG2 	0b00010100 // 18bit STOP, 16bit REFINDEX
#define CFG2 	0b00001100 // 16bit STOP, 16bit REFINDEX
#define CFG16	0b00000000 // LVDS Inputs
//#define CFG16	0b00000100 // CMOS Inputs

#define DVAna31 2147483648


// --------------------------------------------------------------------------
// *** Configuration Registers ***
// --------------------------------------------------------------------------
// A typical config settings = { config00, config01, … , config16 }
//const char config_register[] = {0x03, 0x03, 0x00, 0x40, 0x0D, 0x03, 0xC0, 0xD3, 0xA1, 0x13, 0x00, 0x0A, 0xCC, 0xCC, 0xF1, 0x7D, 0x04};
//const char config_register[16] = {0x35,0x85,0x1F,0x40,0x0D,0x03,0xC0,0x43,0xA1,0x13,0x00,0x0A,0xCC,0xCC,0xF1,0x7D,0x00}; //Pro AS6501 - LVDS


const uint8_t config_register[] ={
		CFG0,
		CFG1,
		CFG2,
		REFCLK_DIVISIONS & 0xFF, 		// CFG3
		(REFCLK_DIVISIONS>>8) & 0xFF, 	// CFG4
		REFCLK_DIVISIONS>>16, 			// CFG5
		0b00000000, // CFG6 - no LVDS test pattern
		0b00000000, // CFG7 - no LVDS adjust
		0xA1, // CFG8  - fixed values
		0x13, // CFG9  - fixed values
		0x00, // CFG10 - fixed values
		0x0A, // CFG11 - fixed values
		0xCC, // CFG12 - fixed values
		0xCC, // CFG13 - fixed values
		0xF1, // CFG14 - fixed values
		0x7D, // CFG15 - fixed values
		CFG16
};


// --------------------------------------------------------------------------
// *** SPI Opcodes ***
// --------------------------------------------------------------------------
const char spiopc_power = 0x30; // opcode for "Power on Reset"
const char spiopc_init = 0x18; // opcode for "Initialize Chip and Start
// Measurement"
const char spiopc_write_config = 0x80; // opcode for "Write Configuration"
const char spiopc_read_config = 0x40; // opcode for "Read Configuration"
const char spiopc_read_results = 0x60; // opcode for "Read Measure Results"
// --------------------------------------------------------------------------
// *** SPI Addresses ***
// --------------------------------------------------------------------------
 const char reference_index_ch1_byte3 = 8;
 const char reference_index_ch1_byte2 = 9;
 const char reference_index_ch1_byte1 = 10;
 const char stopresult_ch1_byte3 = 11;
 const char stopresult_ch1_byte2 = 12;
 const char stopresult_ch1_byte1 = 13;
 // . . . .
 const char stopresult_ch4_byte3 = 29;
 const char stopresult_ch4_byte2 = 30;
 const char stopresult_ch4_byte1 = 31;

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

SAI_HandleTypeDef hsai_BlockA1;
SAI_HandleTypeDef hsai_BlockA3;
DMA_HandleTypeDef hdma_sai1_a;
DMA_HandleTypeDef hdma_sai3_a;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
void PeriphCommonClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
static void MX_DAC1_Init(void);
static void MX_SPI4_Init(void);
static void MX_USART1_UART_Init(void);
static void MX_SAI1_Init(void);
static void MX_SAI3_Init(void);
static void MX_TIM17_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

void pin_manual_SPI()
{
	LL_GPIO_SetPinMode(GPIOE, LL_GPIO_PIN_14, LL_GPIO_MODE_OUTPUT); //MOSI
	LL_GPIO_SetPinMode(GPIOE, LL_GPIO_PIN_12, LL_GPIO_MODE_OUTPUT); //CLK
	LL_GPIO_SetOutputPin(GPIOE, LL_GPIO_PIN_12); //CLK 1
	LL_GPIO_SetPinMode(GPIOE, LL_GPIO_PIN_11, LL_GPIO_MODE_OUTPUT);  //NSS
}


void send_byte_to_SPI(char data)
{
	for(uint8_t i = 0; i<8; i++)
	{
		LL_GPIO_SetOutputPin(GPIOE, LL_GPIO_PIN_12); //CLK
		if(data & (1<<(7-i)))
		{
			LL_GPIO_SetOutputPin(GPIOE, LL_GPIO_PIN_14); //MOSI
		}
		else
		{
			LL_GPIO_ResetOutputPin(GPIOE, LL_GPIO_PIN_14); //MOSI
		}
		LL_GPIO_ResetOutputPin(GPIOE, LL_GPIO_PIN_12); //CLK
	}
}

void AS_config()
{
	// ------------------------------------------------------------------------
	  // *** Power on reset ***
	  // ------------------------------------------------------------------------
	  GPIO_SSN_1; // Reset the SPI interface and select the slave device
	  GPIO_SSN_0;

	  send_byte_to_SPI( spiopc_power ); // Opcode for "Power On Reset" is sent
	  // over SPI
	  // ------------------------------------------------------------------------
	  // *** Writing the configuration registers ***
	  // ------------------------------------------------------------------------

	  GPIO_SSN_1; // Reset the SPI interface and select the slave device
	  GPIO_SSN_0;

	  send_byte_to_SPI( spiopc_write_config + 00 );
	  // Opcode for "Write Configuration” and config address (00) are sent over SPI

	  for (uint8_t i = 0; i < 17; i++) // Send all 17 config registers via SPI
	  send_byte_to_SPI( config_register[i] );


	  GPIO_SSN_1; // Reset SPI interface and select the slave device
	  GPIO_SSN_0;

	  send_byte_to_SPI( spiopc_init );
}

/*USART PC control ------------------------------------------------------------------------------*/

#define MAX_STRLEN 50

char ready = 1;
char command[MAX_STRLEN]; // přijatý řetězec (zpráva)
char answer[MAX_STRLEN]; // řetězec pro zpracování odpovědi
volatile uint8_t num_commands=0; // informuje o příchodu nové zprávy
uint32_t test=0; // něco zajímavého ve zprávě :)
uint8_t scanned=0; // pomocná proměnná

void usart1_it(void) {
	static char received_string[MAX_STRLEN]; // zde se bude ukládat přijímaná zpráva
	static uint16_t cnt = 0; // počítadlo přijatých znaků
	char t;

	// pokud je zdrojem přerušení přijatý znak
	if (LL_USART_IsActiveFlag_RXNE_RXFNE(USART1)) {
		t = LL_USART_ReceiveData8(USART1); // přečti přijatý znak (a maže vlajku RXNE - zdroj přerušení)

		// pokud příchozí znak není konec řádku a ještě máme místo v přijímací paměti
		if ((t != '\r') && (t != '\n') && (cnt < (MAX_STRLEN - 1))) {
			received_string[cnt] = t; // ulož příchozí znak do dočasného pole
			cnt++; // inkrementuj počítadlo znaků
		}
		else { // jinak je to konec příchozí zprávy
			strncpy(command, received_string, cnt); // zkopíruj příkaz do pole command
			command[cnt] = '\0'; // přiřaď na konec řetězce ukončovací znak
			cnt = 0; // vynuluj počítadlo znaků
			num_commands++; // oznam hlavní smyčce že má zprávu ke zpracování
		}
	}
}

void usart1_puts(char *Buffer) {
	while (*Buffer) { // než narazíš na konec řetězce (znak /0)
		while (!LL_USART_IsActiveFlag_TXE(USART1)) {
		}; // čekej než bude volno v Tx Bufferu
		LL_USART_TransmitData8(USART1, *Buffer++); // předej znak k odeslání
	}
}



#define BUFFER_SIZE 256

volatile  uint32_t taga[BUFFER_SIZE] __ATTR_RAM_D1;  // STOPA data (pole v RAM_D1 ! kvůli přístupu DMA1)
volatile  uint32_t tagb[BUFFER_SIZE] __ATTR_RAM_D1;  // STOPB data (pole v RAM_D1 ! kvůli přístupu DMA1)

volatile uint32_t last_start_index = 0;
volatile uint32_t last_stop_index = 0;

volatile 	uint64_t out[256];

volatile uint32_t out_index = 0;


#define index_ch1 (BUFFER_SIZE - (DMA1_Stream0->NDTR) + 256*it_s0)
#define index_ch2 (BUFFER_SIZE - (DMA1_Stream1->NDTR) + 256*it_s1)

#define HIST_ITEMS 170000
#define HIST_BIN_DIV 2

uint16_t hist[HIST_ITEMS] __ATTR_RAM_D1;
long histcount = 0;

long out_of_range = 0;
uint32_t start_time = 0;


void hist_set(uint32_t input)
{
	input = input / HIST_BIN_DIV;
	if(input > start_time && input < (start_time+HIST_ITEMS))
	{
		if(hist[(input-start_time)]  < 0xFFFF)
		{
			hist[(input-start_time)] ++;
			histcount ++;
		}
		else
		{
			ready = 0;

			snprintf(answer, MAX_STRLEN, "Hist peek full\r", histcount);
			usart1_puts(answer);


		}
	}
	else
	{

		//LL_DMA_DisableStream(DMA1, LL_DMA_STREAM_0);
	//	LL_DMA_DisableStream(DMA1, LL_DMA_STREAM_1);
		out_of_range++;

	}
}





/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

	it_s0 = 0;

	it_s1 = 0;


  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

/* Configure the peripherals common clocks */
  PeriphCommonClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_DAC1_Init();
  MX_SPI4_Init();
  MX_USART1_UART_Init();
  MX_SAI1_Init();
  MX_SAI3_Init();
  MX_TIM17_Init();
  /* USER CODE BEGIN 2 */
  HAL_SYSCFG_VREFBUF_VoltageScalingConfig(SYSCFG_VREFBUF_VOLTAGE_SCALE0);

  pin_manual_SPI();
	AS_config();
	LL_mDelay(5);

	memset(taga, 0, sizeof(taga));
	memset(tagb, 0, sizeof(tagb));
	memset(hist, 0, sizeof(hist));
	memset(out, 0, sizeof(out));


	SAI1_Block_A->CR1 |= SAI_xCR1_SAIEN;
	LL_DMA_EnableStream(DMA1, LL_DMA_STREAM_0);
	LL_DMA_EnableIT_TC(DMA1, LL_DMA_STREAM_0);
	SAI1_Block_A->CR1 |= SAI_xCR1_DMAEN;


	SAI3_Block_A->CR1 |= SAI_xCR1_SAIEN;
	  LL_DMA_EnableStream(DMA1, LL_DMA_STREAM_1);
	  LL_DMA_EnableIT_TC(DMA1, LL_DMA_STREAM_1);
	  SAI3_Block_A->CR1 |= SAI_xCR1_DMAEN;




  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
		// pokud přišla nová zpráva
		if (num_commands)
		{
			scanned = strcmp(command, "g_hist_raw"); // pokus se ji přečíst
			if (scanned == 0) {
				for(uint32_t i = 0; i < (sizeof(hist)/sizeof(hist[0])); i ++)
				{
					if( hist[i] != 0)
					{
						snprintf(answer, MAX_STRLEN, "%u-%u \n", i, hist[i]);
						usart1_puts(answer);
					}

				}
			}
			else
			{
				unsigned int  input_data;
				scanned = sscanf(command, "",  &input_data); // pokus se ji přečíst
				if (scanned != 0)
				{
					start_time = input_data;
					snprintf(answer, MAX_STRLEN, "OK - start set to %u  ns",  start_time * (1000000000UL/ REFCLK) / REFCLK_DIVISIONS );
					usart1_puts(answer);

					memset(hist, 0, sizeof(hist));
					out_of_range = 0;
					histcount = 0;
					ready = 1;

				}
				else
				{
					scanned = strcmp(command, "get_stats"); // pokus se ji přečíst
					if (scanned == 0)
					{
						snprintf(answer, MAX_STRLEN, "Out of range: %u (%u ppm)\r", out_of_range, (out_of_range*1000000)/(histcount+1));
						usart1_puts(answer);

						snprintf(answer, MAX_STRLEN, "In histogram: %u\r", histcount);
						usart1_puts(answer);

						    // Initialize maximum element
						    uint16_t  max = hist[0];
						    uint32_t max_index = 0;

						    // Traverse array elements
						    // from second and compare
						    // every element with current max
						    for (uint32_t i = 1; i < HIST_ITEMS; i++)
						    {
							   if (hist[i] > max)
								   {
								   max = hist[i];
								   max_index = i;
								   }
						    }

						    snprintf(answer, MAX_STRLEN, "Hist peak: %u\r", max);
							usart1_puts(answer);

							 snprintf(answer, MAX_STRLEN, "Hist peak index: %u\r", max_index);
							 usart1_puts(answer);

							 if(max == 0xffff)
							 {
								 snprintf(answer, MAX_STRLEN, " !!! FULL !!!\r");
								 usart1_puts(answer);
							 }


					}
					else
					{
						scanned = strcmp(command, "clear"); // pokus se ji přečíst
						if (scanned == 0)
						{
							memset(hist, 0, sizeof(hist));
							out_of_range = 0;
							histcount = 0;
							ready = 1;


							snprintf(answer, MAX_STRLEN, "OK - cleared\r");
							usart1_puts(answer);
						}

						else
						{
							scanned = strcmp(command, "g_start"); // pokus se ji přečíst
							if (scanned == 0)
							{
									snprintf(answer, MAX_STRLEN, "%lu\r", start_time);
									usart1_puts(answer);
							}
						}

					}
				}
			}
			num_commands = 0; // dokončili jsme zpracování zprávy
		}


		if(!ready)
			continue;

		//Zaloha --->     https://pastebin.com/xgJjRFrK


		while(last_start_index+1 < index_ch1) // dokud máme alespoň dva nepřiřazené starty
		 {
				 if( last_stop_index  >=  index_ch2)  //podud  není neprozkoumaná stopka
					 break;

				 while(!(taga[last_start_index & 0xFF] - tagb[last_stop_index& 0xFF]) & 1<<31 && (last_stop_index +1) < index_ch2) //dokud je startovací čas větší než stopka a zároveň mám stopku k dispozici posouvám se dám mezi stopkama
				  {
					 last_stop_index++;
				  }

				 while(!(tagb[last_stop_index& 0xFF] - taga[(last_start_index + 1) & 0xFF ]) & 1<<31 && (last_start_index +1) < index_ch1) //dokud následující start je menší než stopka a mám k dispozici start, posouvám se na další start
				 {
					 last_start_index++;
				 }

				 if(!((tagb[last_stop_index & 0xFF] - taga[last_start_index & 0xFF]) & 1<<31) && last_start_index <index_ch1) //pokud mám k dospozici ještě jeden start a zároveň je čas stopky menší než čas startu, zanesu do grafu a posouvám se na další start
				 {
					 hist_set(tagb[last_stop_index & 0xFF] - taga[last_start_index & 0xFF]);

					 out[out_index& 0xFF] = tagb[last_stop_index& 0xFF] - taga[last_start_index& 0xFF];
					 out_index++;
					last_start_index++;
					last_stop_index++;
					if(!ready)
								break;
				 }
			 }


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Supply configuration update enable
  */
  HAL_PWREx_ConfigSupply(PWR_LDO_SUPPLY);
  /** Configure the main internal regulator output voltage
  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE0);

  while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}
  /** Macro to configure the PLL clock source
  */
  __HAL_RCC_PLL_PLLSOURCE_CONFIG(RCC_PLLSOURCE_HSE);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_BYPASS;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 15;
  RCC_OscInitStruct.PLL.PLLN = 480;
  RCC_OscInitStruct.PLL.PLLP = 2;
  RCC_OscInitStruct.PLL.PLLQ = 10;
  RCC_OscInitStruct.PLL.PLLR = 2;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_1;
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
  RCC_OscInitStruct.PLL.PLLFRACN = 0;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_D3PCLK1|RCC_CLOCKTYPE_D1PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV2;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV2;
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
  HAL_RCC_MCOConfig(RCC_MCO1, RCC_MCO1SOURCE_PLL1QCLK, RCC_MCODIV_1);
  HAL_RCC_MCOConfig(RCC_MCO2, RCC_MCO2SOURCE_PLL2PCLK, RCC_MCODIV_15);
}

/**
  * @brief Peripherals Common Clock Configuration
  * @retval None
  */
void PeriphCommonClock_Config(void)
{
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct = {0};

  /** Enables PLL2P clock output
  */
  __HAL_RCC_PLL2CLKOUT_ENABLE(RCC_PLL2_DIVP);
  /** Initializes the peripherals clock
  */
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_SAI1|RCC_PERIPHCLK_SAI3;
  PeriphClkInitStruct.PLL2.PLL2M = 15;
  PeriphClkInitStruct.PLL2.PLL2N = 150;
  PeriphClkInitStruct.PLL2.PLL2P = 2;
  PeriphClkInitStruct.PLL2.PLL2Q = 2;
  PeriphClkInitStruct.PLL2.PLL2R = 2;
  PeriphClkInitStruct.PLL2.PLL2RGE = RCC_PLL2VCIRANGE_1;
  PeriphClkInitStruct.PLL2.PLL2VCOSEL = RCC_PLL2VCOMEDIUM;
  PeriphClkInitStruct.PLL2.PLL2FRACN = 0;
  PeriphClkInitStruct.Sai1ClockSelection = RCC_SAI1CLKSOURCE_PLL2;
  PeriphClkInitStruct.Sai23ClockSelection = RCC_SAI23CLKSOURCE_PLL2;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief DAC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_DAC1_Init(void)
{

  /* USER CODE BEGIN DAC1_Init 0 */

  /* USER CODE END DAC1_Init 0 */

  LL_DAC_InitTypeDef DAC_InitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* Peripheral clock enable */
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_DAC12);

  LL_AHB4_GRP1_EnableClock(LL_AHB4_GRP1_PERIPH_GPIOA);
  /**DAC1 GPIO Configuration
  PA4   ------> DAC1_OUT1
  PA5   ------> DAC1_OUT2
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_4|LL_GPIO_PIN_5;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* USER CODE BEGIN DAC1_Init 1 */

  /* USER CODE END DAC1_Init 1 */
  /** DAC channel OUT1 config
  */
  DAC_InitStruct.TriggerSource = LL_DAC_TRIG_SOFTWARE;
  DAC_InitStruct.WaveAutoGeneration = LL_DAC_WAVE_AUTO_GENERATION_NONE;
  DAC_InitStruct.OutputBuffer = LL_DAC_OUTPUT_BUFFER_ENABLE;
  DAC_InitStruct.OutputConnection = LL_DAC_OUTPUT_CONNECT_GPIO;
  DAC_InitStruct.OutputMode = LL_DAC_OUTPUT_MODE_NORMAL;
  LL_DAC_Init(DAC1, LL_DAC_CHANNEL_1, &DAC_InitStruct);
  LL_DAC_DisableTrigger(DAC1, LL_DAC_CHANNEL_1);
  /** DAC channel OUT2 config
  */
  LL_DAC_Init(DAC1, LL_DAC_CHANNEL_2, &DAC_InitStruct);
  LL_DAC_DisableTrigger(DAC1, LL_DAC_CHANNEL_2);
  /* USER CODE BEGIN DAC1_Init 2 */
  LL_DAC_Enable(DAC1, LL_DAC_CHANNEL_1);
  LL_DAC_Enable(DAC1, LL_DAC_CHANNEL_2);

  LL_DAC_ConvertData12RightAligned(DAC1, LL_DAC_CHANNEL_1, 491);
  LL_DAC_ConvertData12RightAligned(DAC1, LL_DAC_CHANNEL_2, 2457 );


  /* USER CODE END DAC1_Init 2 */

}

/**
  * @brief SAI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SAI1_Init(void)
{

  /* USER CODE BEGIN SAI1_Init 0 */
	LL_DMA_InitTypeDef dma;
  /* USER CODE END SAI1_Init 0 */

  /* USER CODE BEGIN SAI1_Init 1 */

  /* USER CODE END SAI1_Init 1 */
  hsai_BlockA1.Instance = SAI1_Block_A;
  hsai_BlockA1.Init.Protocol = SAI_FREE_PROTOCOL;
  hsai_BlockA1.Init.AudioMode = SAI_MODESLAVE_RX;
  hsai_BlockA1.Init.DataSize = SAI_DATASIZE_8;
  hsai_BlockA1.Init.FirstBit = SAI_FIRSTBIT_MSB;
  hsai_BlockA1.Init.ClockStrobing = SAI_CLOCKSTROBING_RISINGEDGE;
  hsai_BlockA1.Init.Synchro = SAI_ASYNCHRONOUS;
  hsai_BlockA1.Init.OutputDrive = SAI_OUTPUTDRIVE_DISABLE;
  hsai_BlockA1.Init.FIFOThreshold = SAI_FIFOTHRESHOLD_EMPTY;
  hsai_BlockA1.Init.SynchroExt = SAI_SYNCEXT_DISABLE;
  hsai_BlockA1.Init.MonoStereoMode = SAI_MONOMODE;
  hsai_BlockA1.Init.CompandingMode = SAI_NOCOMPANDING;
  hsai_BlockA1.Init.TriState = SAI_OUTPUT_RELEASED;
  hsai_BlockA1.Init.PdmInit.Activation = DISABLE;
  hsai_BlockA1.Init.PdmInit.MicPairsNbr = 1;
  hsai_BlockA1.Init.PdmInit.ClockEnable = SAI_PDM_CLOCK1_ENABLE;
  hsai_BlockA1.FrameInit.FrameLength = 32;
  hsai_BlockA1.FrameInit.ActiveFrameLength = 7;
  hsai_BlockA1.FrameInit.FSDefinition = SAI_FS_STARTFRAME;
  hsai_BlockA1.FrameInit.FSPolarity = SAI_FS_ACTIVE_HIGH;
  hsai_BlockA1.FrameInit.FSOffset = SAI_FS_FIRSTBIT;
  hsai_BlockA1.SlotInit.FirstBitOffset = 0;
  hsai_BlockA1.SlotInit.SlotSize = SAI_SLOTSIZE_DATASIZE;
  hsai_BlockA1.SlotInit.SlotNumber = 2;
  hsai_BlockA1.SlotInit.SlotActive = 0x00000003;
  if (HAL_SAI_Init(&hsai_BlockA1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SAI1_Init 2 */

  // CubeMX BUG correction
	  hsai_BlockA1.Init.DataSize = SAI_DATASIZE_32;
	  hsai_BlockA1.SlotInit.SlotNumber = 1;
	   hsai_BlockA1.SlotInit.SlotActive = 0x00000001;
   if (HAL_SAI_Init(&hsai_BlockA1) != HAL_OK)
   {
     Error_Handler();
   }

   LL_DMA_StructInit(&dma);
   dma.Direction = LL_DMA_DIRECTION_PERIPH_TO_MEMORY; //direction of data transfer
   dma.Mode = LL_DMA_MODE_CIRCULAR; //go to first after full array
   dma.MemoryOrM2MDstAddress = taga; //address of buffer array
   dma.MemoryOrM2MDstDataSize = LL_DMA_MDATAALIGN_WORD; //32bit data
   dma.MemoryOrM2MDstIncMode = LL_DMA_MEMORY_INCREMENT; //buffer increment
   dma.PeriphOrM2MSrcAddress = (uint32_t)&(SAI1_Block_A->DR); //data source address
   dma.PeriphOrM2MSrcDataSize = LL_DMA_PDATAALIGN_WORD; //32bit data
   dma.PeriphOrM2MSrcIncMode = LL_DMA_PERIPH_NOINCREMENT; //Read from same address
   dma.NbData = sizeof(taga)/sizeof(taga[0]); //Buffer length
   dma.PeriphRequest = LL_DMAMUX1_REQ_SAI1_A; //Select DMA trigger
   dma.Priority = LL_DMA_PRIORITY_MEDIUM; //does not matter
   LL_DMA_Init(DMA1, LL_DMA_STREAM_0, &dma);

  /* USER CODE END SAI1_Init 2 */

}

/**
  * @brief SAI3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SAI3_Init(void)
{

  /* USER CODE BEGIN SAI3_Init 0 */
	LL_DMA_InitTypeDef dma;
  /* USER CODE END SAI3_Init 0 */

  /* USER CODE BEGIN SAI3_Init 1 */

  /* USER CODE END SAI3_Init 1 */
  hsai_BlockA3.Instance = SAI3_Block_A;
  hsai_BlockA3.Init.Protocol = SAI_FREE_PROTOCOL;
  hsai_BlockA3.Init.AudioMode = SAI_MODESLAVE_RX;
  hsai_BlockA3.Init.DataSize = SAI_DATASIZE_8;
  hsai_BlockA3.Init.FirstBit = SAI_FIRSTBIT_MSB;
  hsai_BlockA3.Init.ClockStrobing = SAI_CLOCKSTROBING_RISINGEDGE;
  hsai_BlockA3.Init.Synchro = SAI_ASYNCHRONOUS;
  hsai_BlockA3.Init.OutputDrive = SAI_OUTPUTDRIVE_DISABLE;
  hsai_BlockA3.Init.FIFOThreshold = SAI_FIFOTHRESHOLD_EMPTY;
  hsai_BlockA3.Init.SynchroExt = SAI_SYNCEXT_DISABLE;
  hsai_BlockA3.Init.MonoStereoMode = SAI_MONOMODE;
  hsai_BlockA3.Init.CompandingMode = SAI_NOCOMPANDING;
  hsai_BlockA3.Init.TriState = SAI_OUTPUT_RELEASED;
  hsai_BlockA3.Init.PdmInit.Activation = DISABLE;
  hsai_BlockA3.Init.PdmInit.MicPairsNbr = 1;
  hsai_BlockA3.Init.PdmInit.ClockEnable = SAI_PDM_CLOCK1_ENABLE;
  hsai_BlockA3.FrameInit.FrameLength = 32;
  hsai_BlockA3.FrameInit.ActiveFrameLength = 7;
  hsai_BlockA3.FrameInit.FSDefinition = SAI_FS_STARTFRAME;
  hsai_BlockA3.FrameInit.FSPolarity = SAI_FS_ACTIVE_HIGH;
  hsai_BlockA3.FrameInit.FSOffset = SAI_FS_FIRSTBIT;
  hsai_BlockA3.SlotInit.FirstBitOffset = 0;
  hsai_BlockA3.SlotInit.SlotSize = SAI_SLOTSIZE_DATASIZE;
  hsai_BlockA3.SlotInit.SlotNumber = 2;
  hsai_BlockA3.SlotInit.SlotActive = 0x00000003;
  if (HAL_SAI_Init(&hsai_BlockA3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SAI3_Init 2 */


  // CubeMX BUG correction
  hsai_BlockA3.Init.DataSize = SAI_DATASIZE_32;
  hsai_BlockA3.SlotInit.SlotNumber = 1;
  hsai_BlockA3.SlotInit.SlotActive = 0x00000001;
   if (HAL_SAI_Init(&hsai_BlockA3) != HAL_OK)
   {
     Error_Handler();
   }

   LL_DMA_StructInit(&dma);
   dma.Direction = LL_DMA_DIRECTION_PERIPH_TO_MEMORY;
   dma.Mode = LL_DMA_MODE_CIRCULAR;
   dma.MemoryOrM2MDstAddress = tagb;
   dma.MemoryOrM2MDstDataSize = LL_DMA_MDATAALIGN_WORD;
   dma.MemoryOrM2MDstIncMode = LL_DMA_MEMORY_INCREMENT;
   dma.PeriphOrM2MSrcAddress = (uint32_t)&(SAI3_Block_A->DR);
   dma.PeriphOrM2MSrcDataSize = LL_DMA_PDATAALIGN_WORD;
   dma.PeriphOrM2MSrcIncMode = LL_DMA_PERIPH_NOINCREMENT;
   dma.NbData = sizeof(tagb)/sizeof(tagb[0]);
   dma.PeriphRequest = LL_DMAMUX1_REQ_SAI3_A;
   dma.Priority = LL_DMA_PRIORITY_MEDIUM;
   LL_DMA_Init(DMA1, LL_DMA_STREAM_1, &dma);


  /* USER CODE END SAI3_Init 2 */

}

/**
  * @brief SPI4 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI4_Init(void)
{

  /* USER CODE BEGIN SPI4_Init 0 */

  /* USER CODE END SPI4_Init 0 */

  LL_SPI_InitTypeDef SPI_InitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct = {0};

  /** Initializes the peripherals clock
  */
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_SPI4;
  PeriphClkInitStruct.Spi45ClockSelection = RCC_SPI45CLKSOURCE_D2PCLK1;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /* Peripheral clock enable */
  LL_APB2_GRP1_EnableClock(LL_APB2_GRP1_PERIPH_SPI4);

  LL_AHB4_GRP1_EnableClock(LL_AHB4_GRP1_PERIPH_GPIOE);
  /**SPI4 GPIO Configuration
  PE11   ------> SPI4_NSS
  PE12   ------> SPI4_SCK
  PE13   ------> SPI4_MISO
  PE14   ------> SPI4_MOSI
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_11|LL_GPIO_PIN_12|LL_GPIO_PIN_13|LL_GPIO_PIN_14;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_5;
  LL_GPIO_Init(GPIOE, &GPIO_InitStruct);

  /* USER CODE BEGIN SPI4_Init 1 */

  /* USER CODE END SPI4_Init 1 */
  /* SPI4 parameter configuration*/
  SPI_InitStruct.TransferDirection = LL_SPI_FULL_DUPLEX;
  SPI_InitStruct.Mode = LL_SPI_MODE_MASTER;
  SPI_InitStruct.DataWidth = LL_SPI_DATAWIDTH_4BIT;
  SPI_InitStruct.ClockPolarity = LL_SPI_POLARITY_LOW;
  SPI_InitStruct.ClockPhase = LL_SPI_PHASE_1EDGE;
  SPI_InitStruct.NSS = LL_SPI_NSS_HARD_OUTPUT;
  SPI_InitStruct.BaudRate = LL_SPI_BAUDRATEPRESCALER_DIV2;
  SPI_InitStruct.BitOrder = LL_SPI_MSB_FIRST;
  SPI_InitStruct.CRCCalculation = LL_SPI_CRCCALCULATION_DISABLE;
  SPI_InitStruct.CRCPoly = 0x0;
  LL_SPI_Init(SPI4, &SPI_InitStruct);
  LL_SPI_SetStandard(SPI4, LL_SPI_PROTOCOL_MOTOROLA);
  LL_SPI_EnableNSSPulseMgt(SPI4);
  /* USER CODE BEGIN SPI4_Init 2 */

  /* USER CODE END SPI4_Init 2 */

}

/**
  * @brief TIM17 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM17_Init(void)
{

  /* USER CODE BEGIN TIM17_Init 0 */

  /* USER CODE END TIM17_Init 0 */

  LL_TIM_InitTypeDef TIM_InitStruct = {0};
  LL_TIM_OC_InitTypeDef TIM_OC_InitStruct = {0};
  LL_TIM_BDTR_InitTypeDef TIM_BDTRInitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* Peripheral clock enable */
  LL_APB2_GRP1_EnableClock(LL_APB2_GRP1_PERIPH_TIM17);

  /* USER CODE BEGIN TIM17_Init 1 */

  /* USER CODE END TIM17_Init 1 */
  TIM_InitStruct.Prescaler = 0;
  TIM_InitStruct.CounterMode = LL_TIM_COUNTERMODE_UP;
  TIM_InitStruct.Autoreload = 3;
  TIM_InitStruct.ClockDivision = LL_TIM_CLOCKDIVISION_DIV1;
  TIM_InitStruct.RepetitionCounter = 0;
  LL_TIM_Init(TIM17, &TIM_InitStruct);
  LL_TIM_DisableARRPreload(TIM17);
  LL_TIM_OC_EnablePreload(TIM17, LL_TIM_CHANNEL_CH1);
  TIM_OC_InitStruct.OCMode = LL_TIM_OCMODE_PWM1;
  TIM_OC_InitStruct.OCState = LL_TIM_OCSTATE_DISABLE;
  TIM_OC_InitStruct.OCNState = LL_TIM_OCSTATE_DISABLE;
  TIM_OC_InitStruct.CompareValue = 1;
  TIM_OC_InitStruct.OCPolarity = LL_TIM_OCPOLARITY_HIGH;
  TIM_OC_InitStruct.OCNPolarity = LL_TIM_OCPOLARITY_HIGH;
  TIM_OC_InitStruct.OCIdleState = LL_TIM_OCIDLESTATE_LOW;
  TIM_OC_InitStruct.OCNIdleState = LL_TIM_OCIDLESTATE_LOW;
  LL_TIM_OC_Init(TIM17, LL_TIM_CHANNEL_CH1, &TIM_OC_InitStruct);
  LL_TIM_OC_DisableFast(TIM17, LL_TIM_CHANNEL_CH1);
  TIM_BDTRInitStruct.OSSRState = LL_TIM_OSSR_DISABLE;
  TIM_BDTRInitStruct.OSSIState = LL_TIM_OSSI_DISABLE;
  TIM_BDTRInitStruct.LockLevel = LL_TIM_LOCKLEVEL_OFF;
  TIM_BDTRInitStruct.DeadTime = 0;
  TIM_BDTRInitStruct.BreakState = LL_TIM_BREAK_DISABLE;
  TIM_BDTRInitStruct.BreakPolarity = LL_TIM_BREAK_POLARITY_HIGH;
  TIM_BDTRInitStruct.BreakFilter = LL_TIM_BREAK_FILTER_FDIV1;
  TIM_BDTRInitStruct.AutomaticOutput = LL_TIM_AUTOMATICOUTPUT_DISABLE;
  LL_TIM_BDTR_Init(TIM17, &TIM_BDTRInitStruct);
  /* USER CODE BEGIN TIM17_Init 2 */

  LL_TIM_SetAutoReload(TIM17, 23);

  LL_TIM_OC_SetMode(TIM17, LL_TIM_CHANNEL_CH1, LL_TIM_OCMODE_TOGGLE);
  LL_TIM_CC_EnableChannel(TIM17, LL_TIM_CHANNEL_CH1);
  LL_TIM_EnableAllOutputs(TIM17);
  LL_TIM_EnableCounter(TIM17);


  /* USER CODE END TIM17_Init 2 */
  LL_AHB4_GRP1_EnableClock(LL_AHB4_GRP1_PERIPH_GPIOB);
  /**TIM17 GPIO Configuration
  PB9   ------> TIM17_CH1
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_9;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_VERY_HIGH;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_1;
  LL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  LL_USART_InitTypeDef USART_InitStruct = {0};

  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct = {0};

  /** Initializes the peripherals clock
  */
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_USART1;
  PeriphClkInitStruct.Usart16ClockSelection = RCC_USART16CLKSOURCE_D2PCLK2;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /* Peripheral clock enable */
  LL_APB2_GRP1_EnableClock(LL_APB2_GRP1_PERIPH_USART1);

  LL_AHB4_GRP1_EnableClock(LL_AHB4_GRP1_PERIPH_GPIOB);
  LL_AHB4_GRP1_EnableClock(LL_AHB4_GRP1_PERIPH_GPIOA);
  /**USART1 GPIO Configuration
  PB14   ------> USART1_TX
  PB15   ------> USART1_RX
  PA11   ------> USART1_CTS
  PA12   ------> USART1_RTS
  */
  GPIO_InitStruct.Pin = LL_GPIO_PIN_14|LL_GPIO_PIN_15;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_4;
  LL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  GPIO_InitStruct.Pin = LL_GPIO_PIN_11|LL_GPIO_PIN_12;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_7;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* USART1 interrupt Init */
  NVIC_SetPriority(USART1_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),0, 0));
  NVIC_EnableIRQ(USART1_IRQn);

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  USART_InitStruct.PrescalerValue = LL_USART_PRESCALER_DIV1;
  USART_InitStruct.BaudRate = 115200;
  USART_InitStruct.DataWidth = LL_USART_DATAWIDTH_8B;
  USART_InitStruct.StopBits = LL_USART_STOPBITS_1;
  USART_InitStruct.Parity = LL_USART_PARITY_NONE;
  USART_InitStruct.TransferDirection = LL_USART_DIRECTION_TX_RX;
  USART_InitStruct.HardwareFlowControl = LL_USART_HWCONTROL_NONE;
  USART_InitStruct.OverSampling = LL_USART_OVERSAMPLING_16;
  LL_USART_Init(USART1, &USART_InitStruct);
  LL_USART_SetTXFIFOThreshold(USART1, LL_USART_FIFOTHRESHOLD_1_8);
  LL_USART_SetRXFIFOThreshold(USART1, LL_USART_FIFOTHRESHOLD_1_8);
  LL_USART_DisableFIFO(USART1);
  LL_USART_ConfigAsyncMode(USART1);

  /* USER CODE BEGIN WKUPType USART1 */

  LL_USART_EnableIT_RXNE_RXFNE(USART1);

  /* USER CODE END WKUPType USART1 */

  LL_USART_Enable(USART1);

  /* Polling USART1 initialisation */
  while((!(LL_USART_IsActiveFlag_TEACK(USART1))) || (!(LL_USART_IsActiveFlag_REACK(USART1))))
  {
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/**
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void)
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Stream0_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream0_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream0_IRQn);
  /* DMA1_Stream1_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream1_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream1_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

  /*Configure GPIO pin : PC9 */
  GPIO_InitStruct.Pin = GPIO_PIN_9;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_MEDIUM;
  GPIO_InitStruct.Alternate = GPIO_AF0_MCO;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : PA8 */
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF0_MCO;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
